Subject: RE: bug#13686: hi-yellow vs. hi-lock-1

From: "Drew Adams" <[email-masked]>
Date: Tue, 26 Feb 2013 20:58:10 -0800

> > The main point is that it makes little sense for a face, which is
> > a variable thingy (changeable, customizable), to have a name that
> > suggests otherwise, i.e., suggests that it has some _particular_,
> > constant quality.
> 
> If the user sets the hi-yellow face to red, she gets what she 
> deserves.

Really?  What dos she deserve?  Are you saying that there is some reason she
should not customize the face?  Why use a face then?

> > The face name should reflect what the face is for - the kind of
> > highlighting or whatever that it does.
> 
> Agreed, and hi-yellow is for highlighting some text in yellow, hence
> its name.

If that's really what it's for, then the name is apt.

In that case, a customizable face is not what's needed.  Or else maybe one where
you somehow limit the customization regarding color for various attributes.

> The only real problem is that a user who wants to use a face whose
> attribute do not agree with any of the predefined hi-* faces might end
> up forced to use such a silly setting.

If you provide a customizable face where you don't want one, and you don't limit
it in any way, that's the silliness.  It is not silly for a user to use an
allowed value.
 
> So the right fix is to provide ways for the user to add her own faces.

That would not change the anomalous `hi-<color>' faces.  It would not prevent
the silly settings you mention.

> An alternative might be to let the user specify either a face name or
> a color name, so we can get rid of hi-yellow altogether.  But 
> that still only caters to "highlighting with a color", whereas faces
> offer more choices.

Let the user choose a color.  And let the user choose other attributes.

And if you're going to do all that, then just let the user customize faces,
which do not have any static, inherent colors, even if they might unfortunately
have a color in their names.

IOW, just rename the faces based on what they are really for, not on particular
colors.

Oh, but you said that "hi-yellow is for highlighting...in yellow".  In that
case, it is not also about using other face attributes.  Time to choose.